/*
	$Date: 1997/01/14 16:50:21 $
	$Revision: 1.2 $

	$BCcd%$N=PNO$+$iC18l(B/$BNcJ8$N=P8=IQEY$r7W;;(B/$B=PNO(B
*/
#include <stdio.h>

#define PRIME 9973
int hashpjw(unsigned char *s)
{
	unsigned char *p;
	unsigned h = 0, g;
	for(p=s; *p; p++){
		h = (h<<4) + (*p);
		if(g = h & 0xf0000000){
			h = h ^ (g >> 24);
			h = h ^ g;
		}
	}
	return h % PRIME;
}

typedef struct hash {
	unsigned char *s;
	struct hash *next;
	int count;
} Hash;

Hash *hash[PRIME];

/*
unsigned char *strdup(s)
{
	unsigned char *r;
	r = (unsigned char*)malloc(strlen(s)+1);
	strcpy((char*)r,(char*)s);
	return r;
}
*/

Hash*
newhash(unsigned char *s)
{
	Hash *h;
	h = (Hash*)malloc(sizeof(Hash));
	if(h == NULL){
		fprintf(stderr,"malloc() failed!\n");
		exit(0);
	}
	h->s = (unsigned char*)strdup(s);
/*printf("newhash: h->s = %s\n",h->s); */
	if(h->s == NULL){
		fprintf(stderr,"strdup() failed!\n");
		exit(0);
	}
	h->next = (Hash*)NULL;
	h->count = 1;
	return h;
}

unsigned char*
salloc(char *s)
{
	int h;
	Hash *p;

	h = hashpjw(s);
	if(p = hash[h]){
		while(1){
/*printf("strcmp(%s,%s)\n",p->s,s); */
			if(strcmp(p->s,s)==0){
				p->count++;
				return p->s;
			}
			if(p->next == NULL){
				p->next = newhash(s);
				return p->next->s;
			}
			p = p->next;
		}
	}
	else {
		hash[h] = newhash(s);
		return hash[h]->s;
	}
}

listhash()
{
	int i;
	Hash *p;

	for(i=0;i<PRIME;i++){
		for(p=hash[i];p;p=p->next){
			printf("%d %s\n",p->count,p->s);
		}
	}
}

asciionly(unsigned char *s)
{
	for(;*s;s++){
		if(*s >= 0x80) return 0;
	}
	return 1;
}

unsigned char word[1000],word1[1000],word2[1000],word3[1000];
unsigned char yomi[1000],yomi1[1000];
unsigned char reg[1000];

/*
	$BCcd%$r;H$&$H!V$^$;$s!W$,Fs8l$K$J$C$F$7$^$C$?$j$9$k$N$G!"(B
	$BM=B,7k2L$NJ8;zNs$bFsC18lI=<($7$?J}$,$$$$$+$b$7$l$J$$!#(B
*/

main(int argc, char **argv)
{
	unsigned char buf[1000];
	int phrase = 0;
	int verbose = 0;
	int ccount = 0;		/* $BO"B3C18l?t(B */
	int argp;

	for(argp=1;argp<argc;argp++){
		if(strcmp(argv[argp],"-p")==0) phrase = 1;
		if(strcmp(argv[argp],"-v")==0) verbose = 1;
	}

	while(fgets(buf,1000,stdin) != NULL){
		if(sscanf(buf,"%s %s",word,yomi) != 2) continue;
		if(asciionly(word)){
			ccount = 0;
			continue;
		}
		if(yomi[0] <= 0xa3 || yomi[0] >= 0xa5 || word[0] <= 0xa3){
			ccount = 0;
			continue;
		}

		if(phrase){
			if(ccount > 0){
				sprintf(reg,"%s/%s/%s",word1,word,yomi);
				salloc(reg);
				if(verbose) printf("%s/%s/%s\n",word1,word,yomi);
			}
			if(ccount > 1){
				sprintf(reg,"%s%s/%s/%s",word2,word1,word,yomi);
				salloc(reg);
				if(verbose) printf("%s%s/%s/%s\n",word2,word1,word,yomi);
				sprintf(reg,"%s/%s%s/%s%s",word2,word1,word,yomi1,yomi);
				salloc(reg);
				if(verbose) printf("%s/%s%s/%s%s\n",word2,word1,word,yomi1,yomi);
			}
			if(ccount > 2){
				sprintf(reg,"%s%s/%s%s/%s%s",word3,word2,word1,word,yomi1,yomi);
				salloc(reg);
				if(verbose) printf("%s%s/%s%s/%s%s\n",word3,word2,word1,word,yomi1,yomi);
			}
			strcpy(word3,word2);
			strcpy(word2,word1);
			strcpy(word1,word);
			strcpy(yomi1,yomi);
		}
		else {
			sprintf(reg,"%s/%s",word,yomi);
			salloc(reg);
/*			printf("%s/%s\n",word,yomi); */
		}

		ccount++;
	}
	listhash();
}
